routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::get('invoice', 'PagesController@invoice');

Route::get('/', 'HomeController@index');
Route::get('province/{id}', 'HomeController@province');
Route::get('city/{id}', 'HomeController@city');
Route::get('district/{id}', 'HomeController@district');

Route::get('email/resend', 'Auth\VerificationController@resend');
Auth::routes(['verify' => true]);

Route::get('/home', 'HomeController@index')->name('home');
Route::get('auth/{provider}', 'AuthController@redirectToProvider');
Route::get('auth/{provider}/callback', 'AuthController@handleProviderCallback');

// Chat Module Routes
Route::get('/session/get-friends', 'SessionController@getFriends');
Route::post('/session/create', 'SessionController@create');
Route::post('/session/{session}/chats', 'ChatController@chats');
Route::post('/session/{session}/read', 'ChatController@read');
Route::post('/session/{session}/clear', 'ChatController@clear');
Route::post('/send/{session}', 'ChatController@sendMessage');
Route::post('/session/{session}/block', 'BlockController@block');
Route::post('/session/{session}/unblock', 'BlockController@unblock');

// Drag n Drop Upload Controller
Route::post('upload', 'Admin\UploadController@upload');
Route::delete('revert', 'Admin\UploadController@revert');

Route::get('about-us', 'HomeController@about');
Route::get('galleries', 'HomeController@galleries');

Route::post('cek-mutasi/callback', 'CallbackCekMutasi@cekMutasi');

Route::group(['prefix' => 'admin', 'middleware' => ['role:admin']], function () {
    Route::resource('woods', 'Admin\WoodsController')->except([
        'store', 'update', 'destroy'
    ]);
    Route::resource('banks', 'Admin\BanksController')->except([
        'store', 'update', 'destroy'
    ]);
    Route::resource('finishing', 'Admin\FinishingColorsController')->except([
        'store', 'update', 'destroy'
    ]);
    Route::resource('galleries', 'Admin\GalleriesController')->except([
        'store', 'update', 'destroy'
    ]);
});


Route::group(['prefix' => 'admin', 'middleware' => ['role:superadmin']], function () {
    Route::resource('woods', 'Admin\WoodsController');
    Route::resource('banks', 'Admin\BanksController');
    Route::resource('orders', 'Admin\OrdersController')->name('index', 'admin.orders');
    Route::resource('finishing', 'Admin\FinishingColorsController');
    Route::resource('galleries', 'Admin\GalleriesController');
});

Route::group(['prefix' => 'admin', 'middleware' => ['role:admin|superadmin']], function () {
    Route::get('/', 'Admin\DashboardController@index');
    Route::resource('dashboard', 'Admin\DashboardController');
    Route::get('chat', 'ChatController@index');

    Route::resource('orders', 'Admin\OrdersController')->name('index', 'admin.orders');

    Route::get('customers', 'Admin\CustomersController@index')->name('customers.index');
    Route::get('customers/{id}', 'Admin\CustomersController@show');

    Route::get('orders/detail/{id}', 'Admin\OrdersController@detail')->name('orders.detail');
    Route::post('orders/process', 'Admin\OrdersController@process')->name('orders.process');
    Route::post('orders/cancel', 'Admin\OrdersController@cancel')->name('orders.cancel');
    Route::post('orders/set-paid', 'Admin\OrdersController@paid');
    Route::post('orders/airbill', 'Admin\OrdersController@updateAirbill')->name('orders.airbill');
    Route::get('orders/invoice/{id}', 'Admin\OrdersController@printInvoice')->name('orders.invoice');
    Route::post('order/set_payment_complete', 'Admin\OrdersController@setOrderPaymentComplete')->name('orders.set_payment_complete');

    Route::get('settings', 'Admin\SettingsController@index')->name('settings');
    Route::put('settings/{id}', 'Admin\SettingsController@update')->name('settings.update');
    Route::post('settings/password', 'Admin\SettingsController@password')->name('settings.password');
});



Route::group(['prefix' => 'customer', 'middleware' => ['role:customer']], function () {
    Route::resource('dashboard', 'Customer\DashboardController');
    Route::resource('orders', 'Customer\OrdersController');

    Route::post('orders/set-paid', 'Customer\OrdersController@paid');
    Route::get('history', 'Customer\OrdersController@history')->name('history');
    Route::get('chat', 'ChatController@index');
    Route::get('profile', 'Customer\ProfileController@index');
    Route::get('how-to-order', 'Customer\PagesController@howToOrder');
    Route::get('profile/edit', 'Customer\ProfileController@edit')->name('profile.edit');
    Route::get('orders/detail/{id}', 'Customer\OrdersController@detail');
    Route::post('orders/reorder', 'Customer\OrdersController@repeatOrder');
    Route::put('profile/{id}', 'Customer\ProfileController@update')->name('profile.update');
    Route::post('profile/password', 'Customer\ProfileController@password')->name('profile.password');

    Route::get('woods/{id}', 'Customer\OrdersController@getWoodsWith');
    Route::get('finishing/{id}', 'Customer\OrdersController@getFinishingColor');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

resources/views/admin/finishing/create.blade.php
@extends('layouts.admin')

@section('title')
  Tambah Jenis Warna Finishing
@endsection

@push('style')
  <link rel="stylesheet" href="{{ asset('css/filepond.css') }}">
  <link rel="stylesheet" href="{{ asset('css/filepond-plugin-image-preview.css') }}">
   <link rel="stylesheet" href="{{ asset('plugins/selectpicker/css/bootstrap-select.min.css') }}">
@endpush

@section('content')
<div class="col-lg-10 col-md-9 p-4">

  	<div class="row pl-3 pt-2">
  		<div class="col-lg-12 col-sm-12 col-md-12">
            <div class="card">
                <div class="card-header bg-primary text-light mb-1">
                  <h5>Tambah Jenis Warna Finishing</h5>
                </div>
                <div class="card-body">
                    <form method="post" action="{{ route('finishing.store') }}" >
                    	@csrf
                        
                        <div class="form-group row">
                          <label for="finishing_color_name" class="col-sm-3 col-form-label">Nama Warna Finishing</label>
                          <div class="col-sm-9">
                            <input
                            	name="finishing_color_name"
                            	type="text"
                            	class="form-control {{ $errors->has('finishing_color_name') ? ' is-invalid' : '' }}"
                              value="{{ old('finishing_color_name') }}"
                            	placeholder="Nama Jenis Warna Finishing">
                              @if ($errors->has('finishing_color_name'))
                                <div class="invalid-feedback has-error-required" role="alert">
                                    {{ $errors->first('finishing_color_name') }}
                                </div>
                              @endif
                          </div>
                        </div>

                        <div class="form-group row">
                          <label for="wood_finishings" class="col-sm-3 col-form-label">Finishing Untuk Jenis Kayu</label>
                          <div class="col-sm-9">
                            <select multiple data-live-search="true" class="form-control" name="wood_finishings[]" id="wood_finishings">
                              @foreach ($woods as $row)
                                <option value="{{ $row->id }}">{{ $row->wood_name }}</option>
                              @endforeach
                            </select>

                            @if ($errors->has('wood_finishings'))
                              <div class="invalid-feedback has-error-required" role="alert">
                                  {{ $errors->first('wood_finishings') }}
                              </div>
                            @endif
                          </div>
                        </div>
                        
                        <div class="form-group row">
                          <label for="photo" class="col-sm-3 col-form-label">Foto</label>
                          <div class="col-sm-9">
                            <input
                              class="my-pond"
                              name="photo"
                              type="file"
                              class="form-control"/>

                          </div>

                        </div>
                        
                        <div class="form-group row">
                        	<div class="col-sm-3"></div>
                          <div class="col-sm-9">
                            <button type="submit" class="btn btn-primary">Simpan</button>
                            <a href="{{ route('finishing.index') }}" class="btn btn-warning">Batal</a>
                          </div>
                        </div>
                      </form>
                </div>
            </div>
  	</div>
</div>
@endsection

@push('script')

  <script src="{{ asset('js/filepond.js') }}"></script>
  <script src="{{ asset('js/filepond-plugin-image-preview.js') }}"></script>
  <script src="{{ asset('js/filepond.jquery.js') }}"></script>
  <script src="{{ asset('plugins/selectpicker/js/bootstrap-select.min.js') }}"></script>
  <script>
    bootstrapValidate('[name=finishing_color_name]','required:Nama Jenis Warna Finishing Wajib Diisi!');

    $('select').selectpicker();

    $(function(){
      // First register any plugins
      $.fn.filepond.registerPlugin(FilePondPluginImagePreview);
      $.fn.filepond.setOptions({
        server: {
          process: {
              url: '/upload',
              headers: {
                  'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
              }
          },
          revert: {
            url: '/revert',
            headers: {
                'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
            }
          }
        }
      });


      // Turn input element into a pond
      $('.my-pond').filepond();

      $('.my-pond').filepond('required', true);
    
      // Listen for addfile event
      $('.my-pond').on('FilePond:addfile', function(e) {
          console.log('file added event', e);
      });
    });
  </script>
@endpush

resources/views/admin/finishing/edit.blade.php
@extends('layouts.admin')

@section('title')
  Ubah Jenis Warna Finishing
@endsection

@push('style')
  <link rel="stylesheet" href="{{ asset('css/filepond.css') }}">
  <link rel="stylesheet" href="{{ asset('css/filepond-plugin-image-preview.css') }}">
   <link rel="stylesheet" href="{{ asset('plugins/selectpicker/css/bootstrap-select.min.css') }}">
@endpush

@section('content')
<div class="col-lg-10 col-md-9 p-4">

  	<div class="row pl-3 pt-2">
  		<div class="col-lg-12 col-sm-12 col-md-12">
            <div class="card">
                <div class="card-header bg-primary text-light mb-1">
                  <h5>Ubah Jenis Warna Finishing</h5>
                </div>
                <div class="card-body">
                    <form method="post" enctype="multipart/form-data" action="{{ route('finishing.update', $finishing->id) }}" >
                    	@csrf
                        @method('PUT')
                        <div class="form-group row">
                          <label for="finishing_color_name" class="col-sm-3 col-form-label">Nama Warna Finishing</label>
                          <div class="col-sm-9">
                            <input
                            	name="finishing_color_name"
                            	type="text"
                            	class="form-control{{ $errors->has('finishing_color_name') ? ' is-invalid' : '' }}"
                              value="{{ $finishing->finishing_color_name }}"
                            	placeholder="Nama Jenis Warna Finishing">
                              @if ($errors->has('finishing_color_name'))
                                <div class="invalid-feedback has-error-required" role="alert">
                                    {{ $errors->first('finishing_color_name') }}
                                </div>
                              @endif
                          </div>
                        </div>

                        <div class="form-group row">
                          <label for="wood_finishings" class="col-sm-3 col-form-label">Finishing Untuk Jenis Kayu</label>
                          <div class="col-sm-9">
                            <select data-actions-box="true" multiple data-live-search="true" class="form-control" name="wood_finishings[]" id="wood_finishings">
                              @foreach ($woods as $row)
                                <option value="{{ $row->id }}">{{ $row->wood_name }}</option>
                              @endforeach
                            </select>

                            @if ($errors->has('wood_finishings'))
                              <div class="invalid-feedback has-error-required" role="alert">
                                  {{ $errors->first('wood_finishings') }}
                              </div>
                            @endif
                          </div>
                        </div>
                        
                        <div class="form-group row">
                          <label for="photo" class="col-sm-3 col-form-label">Foto</label>
                          <div class="col-sm-9">
                            <input
                              class="my-pond"
                              name="photo"
                              type="file"
                              class="form-control"/>

                          </div>

                        </div>
                        
                        <div class="form-group row">
                          <label class="col-sm-3 col-form-label"></label>
                          <div class="col-sm-9">
                            <img src="{{ asset('storage/finishings/' . $finishing->photo) }}" alt="" class="img-fluid thumbnail">

                          </div>
                        </div>

                        
                        <div class="form-group row">
                        	<div class="col-sm-3"></div>
                          <div class="col-sm-9">
                            <button type="submit" class="btn btn-primary">Simpan</button>
                            <a href="{{ route('finishing.index') }}" class="btn btn-warning">Batal</a>
                          </div>
                        </div>
                      </form>
                </div>
            </div>
  	</div>
</div>
@endsection


@push('script')

  <script src="{{ asset('js/filepond.js') }}"></script>
  <script src="{{ asset('js/filepond-plugin-image-preview.js') }}"></script>
  <script src="{{ asset('js/filepond.jquery.js') }}"></script>
  <script src="{{ asset('plugins/selectpicker/js/bootstrap-select.min.js') }}"></script>
  <script>

    bootstrapValidate('[name=finishing_color_name]','required:Nama Jenis Warna Finishing Wajib Diisi!');

    $('select').selectpicker();
    getSelected();

    $(function(){

      // First register any plugins
      $.fn.filepond.registerPlugin(FilePondPluginImagePreview);
      $.fn.filepond.setOptions({
        server: {
          process: {
              url: '/upload',
              headers: {
                  'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
              }
          },
          revert: {
            url: '/revert',
            headers: {
                'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
            }
          }
        }
      });


      // Turn input element into a pond
      $('.my-pond').filepond();
    
      // Listen for addfile event
      $('.my-pond').on('FilePond:addfile', function(e) {
          console.log('file added event', e);
      });
    });

    function getSelected(){
      let url = `{{ route('finishing.show', $finishing->id) }}`;
      let woods = [];
      axios.get(url)
        .then(res => {
          let data = res.data;
          $.each(data.woods, (key,val) => {
            woods.push(val.id);
          });
          $('select').selectpicker('val', woods);
          $('select').selectpicker('refresh');
        })  
        .catch(err=>{
          console.log(err);
        });
    }

  </script>
@endpush

resources/views/admin/finishing/index.blade.php
@extends('layouts.admin')

@section('title', 'Finishing Warna')


@push('style')
	<link rel="stylesheet" href="{{ asset('css/jquery.fancybox.css') }}">
@endpush

@section('content')
<div class="col-lg-10 col-md-9 p-4">
    <div class="row h-100">
      <div class="col-md-12 pl-3 pt-2">
          	<div class="pl-3">
              	<h3>Data Jenis Finishing Warna</h3>
              	<div>
                  	<p class="text-muted">
                    Menampilkan Data Jenis Finishing Warna
                  	</p>
              	</div>
          	</div>

          	<div class="pl-3">
              	<div class="card">
	  			<div class="card-header">
  					<a href="{{ route('finishing.create') }}" class="btn btn-primary"><span class="oi io-plus"></span> Tambah Finishing Warna</a>
	  			</div>
	  			<div class="card-body">
					
					<div class="ml-auto mb-3">
  						<form action="{{ route('finishing.index') }}">
					        <div class="input-group">
					        	<input
						          value="{{Request::get('keyword')}}"
						          name="keyword"
						          class="form-control"
						          type="text"
						          placeholder="Cari Berdasarkan Nama Finishing Warna"/>
						          <div class="input-group-append">
					                <input
					                type="submit"
					                value="Cari"
					                class="btn btn-primary">
					            </div>
						    </div>
						    
						</form>
  					</div>
			    	
	  				<table class="table table-striped" id="data-table">
						<thead>
							<th>No.</th>
							<th>Nama Finishing Warna</th>
							<th>Untuk Jenis Kayu</th>
							<th>Foto</th>
							<th>Action</th>
						</thead>
						<tbody>
							@if (count($finishings)>0)
								@php
									$no = $finishings->firstItem();
								@endphp
								@foreach ($finishings as $finishing)
									<tr>
										<td>{{ $no++}}</td>
										<td>{{ $finishing->finishing_color_name }}</td>
										<td>
											@foreach ($finishing->woods as $wood)
												<li>{{ $wood->wood_name }}</li>
											@endforeach
										</td>
										<td>
											<a data-fancybox="images" href="{{ asset('storage/finishings/' . $finishing->photo) }}"><img style="width: 100px" class="thumbnail" src="{{ asset('storage/finishings/' . $finishing->photo) }}"></a>
										</td>
										<td>
											<a href="{{ route('finishing.edit', $finishing->id) }}" class="btn btn-info"><span class="oi oi-pencil"></span></a>
											<a onclick="removeData({{ $finishing->id }})" href="javascript:void(0)" class="btn btn-delete btn-danger"><span class="oi oi-trash"></span></a>
										</td>
									</tr>
								@endforeach
							@else
								<tr>
									<td colspan="5" class="text-center">Maaf, Data Kosong</td>
								</tr>
							@endif
							
							
						</tbody>
					</table>
					{{ $finishings->links() }}
	  			</div>
	  		</div>
      </div>
    </div>
</div>
@endsection

@push('script')
	<script src="{{ asset('js/jquery.fancybox.js') }}"></script>
	<script>
    
	function removeData(id){
		let route = `finishing/${id}`;
		window.fn.delete(id,route);
	}

    @if (session()->has('success'))
      $(function(){
        swal("Sukses", `{{ session()->get('success') }}`, "success")
      });
    @endif
</script>
@endpush